﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Interactivity;
using System.Windows.Media;

namespace TestProject
{
    /// <summary>
    /// 전경색 변경 액션
    /// </summary>
    public class ChangeForegroundAction : TriggerAction<TextBlock>
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Dependency Property
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 전경 브러시 속성 - ForegroundProperty

        /// <summary>
        /// 전경 브러시 속성
        /// </summary>
        public static readonly DependencyProperty ForegroundProperty = DependencyProperty.Register
        (
            "Foreground", 
            typeof(Brush), 
            typeof(ChangeForegroundAction), 
            new PropertyMetadata(Brushes.Black)
        );

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 전경 브러시 - Foreground

        /// <summary>
        /// 전경 브러시
        /// </summary>
        public Brush Foreground
        {
            get
            {
                return (Brush)GetValue(ForegroundProperty);
            }
            set
            {
                SetValue(ForegroundProperty, value);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 호출하기 - Invoke(parameter)

        /// <summary>
        /// 호출하기
        /// </summary>
        /// <param name="parameter">매개 변수</param>
        protected override void Invoke(object parameter)
        {
            TextBlock textBlock = AssociatedObject as TextBlock;

            if(textBlock == null || parameter == null)
            {
                return;
            }

            string parametString = parameter.ToString().ToUpper();

            if(parametString == "ALARM")
            {
                textBlock.Foreground = Foreground;
            }
            else 
            {
                textBlock.Foreground = Brushes.Black;
            }
        }

        #endregion
    }
}